# Sourcemod Admin Donation 1.0
# Requires:
#			Eventscripts 2.0+
#			Sourcemod 2.0+
#			A Website/Domain with MySql Databases
#			Paypal Account
#			Donators (I couldn't resist)
#			sql-admin-manager.smx needs to be [ENABLED] (Take it out of the disabled folder in sourcemod/plugins)

import es, cfglib, playerlib, popuplib, os.path, cPickle, urllib, usermsg

sadcfg = cfglib.AddonCFG(es.getAddonPath("sad") + "/settings.cfg")

sadcfg.text('*************************************')
sadcfg.text('***** Sourcemod Admin Donations *****')
sadcfg.text('*************************************')
sadgroupname	=	sadcfg.cvar('sadgroupname',	'basic admin',	'The Basic Admin Group Name. MUST BE THE SAME AS THE ONE YOU MADE FOR THE DATABASE!')
sadadvgroupname	=	sadcfg.cvar('sadadvgroupname',	'advanced admin',	'The Advanced Admin Group Name. MUST BE THE SAME AS THE ONE YOU MADE FOR THE DATABASE!')
sadcfg.text('*************************************')
sadurl			=	sadcfg.cvar('sadurl',		'http://yourdomain.com/sad/',	'URL for donations and SteamID Checking. NEEDS TO BE VALID!')
sadcfg.text('*************************************')
sadadverts		=	sadcfg.cvar('sadadverts',	1,	'Displays an advert on each round start which shows where to donate for admin')
sadadcol		=	sadcfg.cvar('sadadcol',		'blue',	'The colour the Website will be when advertised. **Colours: red, blue, lightgreen, green, default**')
sadpopups		=	sadcfg.cvar('sadpopups',	1,	'Enable the popups showing the Commands you offer for each group')

sadcfg.write()
# This is where you edit the flags!
sadflags = ('reservation','generic','kick','ban','unban','slay','changemap','cvars','config','chat','vote','password','rcon','cheats','custom1','custom2','custom3','custom4','custom5','custom6','root')
sadadvflags = ('reservation','generic','kick','ban','unban','slay','changemap','cvars','config','chat','vote','password','rcon','cheats','custom1','custom2','custom3','custom4','custom5','custom6','root')

steamlist = []
advsteamlist = []

admins = {}

info = es.AddonInfo()
info.name = "Sourcemod Admin Donations"
info.version = "1.0"
info.author = "Owned|Myself"
info.url = "http://www.csselites.co.uk/"
info.basename = "sad"
info.description = "Allows Players to donate for admin and get it automatically, with no maintenance."

def load():
    global admins
    global steamlist
    global advsteamlist
    sadcfg.execute()
    es.setinfo('sad_version',	info.version)
    es.makepublic('sad_version')
    if sadpopups == 1:
        es.regsaycmd('!sadcommands', 'sad/sadcommands', 'Sourcemod Flags Enabled')
        es.regsaycmd('!sadadvcommands', 'sad/sadadvcommands', 'Advanced Sourcemod Flags')
    str_path = es.getAddonPath('sad') + '/admins.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        admins = cPickle.load(file_users)
        file_users.close()

def unload():
    if sadpopups == 1:
        es.unregsaycmd('!sadcommands')
        es.unregsaycmd('!sadadvcommands')

def sadcommands():
    userid = es.getcmduserid()
    sadcommandspopup = popuplib.easymenu('sad_commands', '_popup_choice', sadcommands_menuselect)
    sadcommandspopup.settitle('S.A.D Commands')
    for f in sadflags:
        sadcommandspopup.addoption(f, f)
    popuplib.send('sad_commands', userid)

def sadadvcommands():
    userid = es.getcmduserid()
    sadadvcommandspopup = popuplib.easymenu('sad_advcommands', '_popup_choice', sadadvcommands_menuselect)
    sadadvcommandspopup.settitle('S.A.D Advanced Commands')
    for f in sadadvflags:
        sadadvcommandspopup.addoption(f, f)
    popuplib.send('sad_advcommands', userid)

def sadcommands_menuselect(userid, choice, popupid):
    es.tell(userid, 'Type @menu to access the Menu if you donated!')
def sadadvcommands_menuselect(userid, choice, popupid):
    es.tell(userid, 'Type @menu to access the Menu if you donated!')

def player_activate(event_var):
    steam = es.getplayersteamid(event_var['userid'])
    name = es.getplayername(event_var['userid'])
    while len(steamlist) > 0:
        steamlist.remove(steamlist[0])
    for line in urllib.urlopen(sadurl+"steam.php"):
        steamlist.append(line[:line.rfind("\n")])
    while len(advancedsteamlist) > 0:
        advancedsteamlist.remove(advancedsteamlist[0])
    for line in urllib.urlopen(sadurl+"advsteam.php"):
        advancedsteamlist.append(line[:line.rfind("\n")])
    if steam in steamlist:
        if not admins.has_key(steam):
            admins[steam] = {}
            admins[steam]['expired'] = 0
            es.server.queuecmd('sm_sql_addadmin "%s" steam "%s"'%(name, steam))
            es.server.queuecmd('sm_sql_setadmingroups steam "%s" "%s"'%(steam, sadgroupname))
            es.tell(event_var['userid'], 'Thanks for Donating! You have been added to the admin list!')
            str_path = open(es.getAddonPath('sad') + '/admins.db', 'wb')
            cPickle.dump(admins, str_path)
            str_path.close()
        elif admins[steam]['expired'] == 1:
            admins[steam]['expired'] = 0
            es.server.queuecmd('sm_sql_addadmin "%s" steam "%s"'%(name, steam))
            es.server.queuecmd('sm_sql_setadmingroups steam "%s" "%s"'%(steam, sadgroupname))
            es.tell(event_var['userid'], 'Thanks for Donating again! You have been added to the admin list!')
            str_path = open(es.getAddonPath('sad') + '/admins.db', 'wb')
            cPickle.dump(admins, str_path)
            str_path.close()
    elif steam in advsteamlist:
        if not admins.has_key(steam):
            admins[steam] = {}
            admins[steam]['expired'] = 0
            es.server.queuecmd('sm_sql_addadmin "%s" steam "%s"'%(name, steam))
            es.server.queuecmd('sm_sql_setadmingroups steam "%s" "%s"'%(steam, sadadvgroupname))
            es.tell(event_var['userid'], 'Thanks for Donating! You have been added to the advanced admin list!')
            str_path = open(es.getAddonPath('sad') + '/admins.db', 'wb')
            cPickle.dump(admins, str_path)
            str_path.close()
        elif admins[steam]['expired'] == 1:
            admins[steam]['expired'] = 0
            es.server.queuecmd('sm_sql_addadmin "%s" steam "%s"'%(name, steam))
            es.server.queuecmd('sm_sql_setadmingroups steam "%s" "%s"'%(steam, sadadvgroupname))
            es.tell(event_var['userid'], 'Thanks for Donating again! You have been added to the advanced admin list!')
            str_path = open(es.getAddonPath('sad') + '/admins.db', 'wb')
            cPickle.dump(admins, str_path)
            str_path.close()
    else:
        if admins.has_key(steam):
            if admins[steam]['expired'] == 0:
                admins[steam]['expired'] = 1
                es.server.queuecmd('sm_sql_deladmin steam "%s"'%(steam))
                str_path = open(es.getAddonPath('sad') + '/admins.db', 'wb')
                cPickle.dump(admins, str_path)
                str_path.close()